static char pix;
static char s1,s2;
static char red,grn,blu,x1,y1;
static unsigned char c1,d1,e1;




#define spi_clk   PORTB.F7   // pin clock
#define spi_dta   PORTB.F6   // pin data
#define spi_cs    PORTB.F5   // pin select
#define spi_reset PORTB.F4   // pin reset


#define CS0 spi_cs=0;
#define CS1 spi_cs=1;
#define CLK0 spi_clk=0;
#define CLK1 spi_clk=1;
#define SDA0 spi_dta=0;
#define SDA1 spi_dta=1;
#define RESET0 spi_reset=0;
#define RESET1 spi_reset=1;


void sendCMD(char cmd);
void sendData(char cmd);
void shiftBits(char b);
void setPixel(char r,char g,char b);

 void shiftBits(char b) {

  CLK0
  if ((b&128)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&64)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&32)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&16)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&8)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&4)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&2)!=0) SDA1 else SDA0
  CLK1

  CLK0
  if ((b&1)!=0) SDA1 else SDA0
  CLK1

}


//send command
void sendCMD(char datax) {

  CLK0
  SDA0                      //0 indicates command
  CLK1
  shiftBits(datax);
}



void sendData(char datax) {

  CLK0
  SDA1                      //1 indicates data
  CLK1

  shiftBits(datax);

}

void setPixel(char r_,char g_,char b_) {

  red=r_;
  grn=g_;
  blu=b_;
  if (pix==0) {    // even pixel
    s1=(red & 0xF0) | (grn>>4);
    s2=(blu & 0xF0);
    pix=1;
  } else {    //odd pixel
    pix=0;
    sendData(s1);
    sendData(s2|(red>>4));
    sendData((grn & 0xF0) | (blu>>4));
  }

}




 void main(){

  char *text;
  char mem_data;
  unsigned char tmp;
  unsigned i;
  
  
  PORTB = 0;
  TRISB = 0;

  CS0
  SDA0
  CLK1


 RESET1          //Send harware RESET signal
 delay_ms(10);
 RESET0
 delay_ms(10);
 RESET1

  CLK1
  SDA1
  CLK1

  delay_ms(10);

 //Software Reset
  sendCMD(0x01);

  //Sleep Out
  sendCMD(0x11);

  //Booster ON
  sendCMD(0x03);

  delay_ms(10);

  //Display On
  sendCMD(0x29);

  //Normal display mode
  sendCMD(0x13);

  //Display inversion off
  sendCMD(0x20);

  //Data order
  sendCMD(0xBA);


  sendCMD(0x3A);
  sendData(3);   //12-Bit per Pixel (default)

  //Set Constrast
  sendCMD(0x25);
  sendData(127);

  //Column Adress Set
  sendCMD(0x2A);
  sendData(20);
  sendData(49);

  //Page Adress Set
  sendCMD(0x2B);
  sendData(40);
  sendData(79);

  //Memory Write
  sendCMD(0x2C);

 //paint display area
 do {
  //red bar
  for (i=0;i<30*40;i++) {
    setPixel(255,0,0);
  }
  delay_ms(1000);

  for (i=0;i<30*40;i++) {
    setPixel(255,240,0);
  }
  delay_ms(1000);
}while(1);





}